*** a/doc/src/sgml/catalogs.sgml
--- b/doc/src/sgml/catalogs.sgml
***************
*** 1081,1088 ****
        <entry><type>bool</type></entry>
        <entry></entry>
        <entry>
!        This represents a not-null constraint.  It is possible to
!        change this column to enable or disable the constraint.
        </entry>
       </row>
  
--- 1081,1090 ----
        <entry><type>bool</type></entry>
        <entry></entry>
        <entry>
!        This represents a non nullable column.  This may be either because
!        of a not null constraint, or because of a primary key. 
!        The <structname>pg_constraint</structname> catalog contains the complete
!        information; this column should be considered just a cache.
        </entry>
       </row>
  
***************
*** 1825,1835 ****
  
    <para>
     The catalog <structname>pg_constraint</structname> stores check, primary
!    key, unique, foreign key, and exclusion constraints on tables.
     (Column constraints are not treated specially.  Every column constraint is
     equivalent to some table constraint.)
-    Not-null constraints are represented in the <structname>pg_attribute</>
-    catalog, not here.
    </para>
  
    <para>
--- 1827,1836 ----
  
    <para>
     The catalog <structname>pg_constraint</structname> stores check, primary
!    key, unique, foreign key, exclusion, and not null constraints
!    on tables.
     (Column constraints are not treated specially.  Every column constraint is
     equivalent to some table constraint.)
    </para>
  
    <para>
***************
*** 1838,1844 ****
    </para>
  
    <para>
!    Check constraints on domains are stored here, too.
    </para>
  
    <table>
--- 1839,1845 ----
    </para>
  
    <para>
!    Check and not null constraints on domains are stored here, too.
    </para>
  
    <table>
***************
*** 1878,1883 ****
--- 1879,1885 ----
        <entry>
          <literal>c</> = check constraint,
          <literal>f</> = foreign key constraint,
+         <literal>n</> = not-null constraint,
          <literal>p</> = primary key constraint,
          <literal>u</> = unique constraint,
          <literal>t</> = constraint trigger,
***************
*** 1999,2005 ****
        <entry><type>int2[]</type></entry>
        <entry><literal><link linkend="catalog-pg-attribute"><structname>pg_attribute</structname></link>.attnum</></entry>
        <entry>If a table constraint (including foreign keys, but not constraint
!        triggers), list of the constrained columns</entry>
       </row>
  
       <row>
--- 2001,2008 ----
        <entry><type>int2[]</type></entry>
        <entry><literal><link linkend="catalog-pg-attribute"><structname>pg_attribute</structname></link>.attnum</></entry>
        <entry>If a table constraint (including foreign keys, but not constraint
!        triggers), list of the constrained columns. This column is used to store
!        the referenced attribute number of a not-null constraint, too</entry>
       </row>
  
       <row>
*** a/src/backend/access/common/tupdesc.c
--- b/src/backend/access/common/tupdesc.c
***************
*** 557,562 **** BuildDescForRelation(List *schema)
--- 557,563 ----
  	foreach(l, schema)
  	{
  		ColumnDef  *entry = lfirst(l);
+ 		bool		notnull;
  
  		/*
  		 * for each entry in the list, get the name and type information from
***************
*** 585,592 **** BuildDescForRelation(List *schema)
  			desc->attrs[attnum - 1]->attstorage = entry->storage;
  
  		/* Fill in additional stuff not handled by TupleDescInitEntry */
! 		desc->attrs[attnum - 1]->attnotnull = entry->is_not_null;
! 		has_not_null |= entry->is_not_null;
  		desc->attrs[attnum - 1]->attislocal = entry->is_local;
  		desc->attrs[attnum - 1]->attinhcount = entry->inhcount;
  	}
--- 586,594 ----
  			desc->attrs[attnum - 1]->attstorage = entry->storage;
  
  		/* Fill in additional stuff not handled by TupleDescInitEntry */
! 		notnull = entry->is_not_null | entry->is_primary_key;
! 		has_not_null |= notnull;
! 		desc->attrs[attnum - 1]->attnotnull = notnull;
  		desc->attrs[attnum - 1]->attislocal = entry->is_local;
  		desc->attrs[attnum - 1]->attinhcount = entry->inhcount;
  	}
*** a/src/backend/catalog/index.c
--- b/src/backend/catalog/index.c
***************
*** 174,181 **** relationHasPrimaryKey(Relation rel)
   * are simple column references (not expressions), and that all those
   * columns are marked NOT NULL.  If they aren't (which can only happen during
   * ALTER TABLE ADD CONSTRAINT, since the parser forces such columns to be
!  * created NOT NULL during CREATE TABLE), do an ALTER SET NOT NULL to mark
!  * them so --- or fail if they are not in fact nonnull.
   *
   * Caller had better have at least ShareLock on the table, else the not-null
   * checking isn't trustworthy.
--- 174,182 ----
   * are simple column references (not expressions), and that all those
   * columns are marked NOT NULL.  If they aren't (which can only happen during
   * ALTER TABLE ADD CONSTRAINT, since the parser forces such columns to be
!  * created NOT NULL during CREATE TABLE; or if they come from an inherited
!  * relation), do an ALTER SET NOT NULL to mark them so --- or fail if they are
!  * not in fact nonnull.
   *
   * Caller had better have at least ShareLock on the table, else the not-null
   * checking isn't trustworthy.
***************
*** 236,242 **** index_check_primary_key(Relation heapRel,
  			/* Add a subcommand to make this one NOT NULL */
  			AlterTableCmd *cmd = makeNode(AlterTableCmd);
  
! 			cmd->subtype = AT_SetNotNull;
  			cmd->name = pstrdup(NameStr(attform->attname));
  			cmds = lappend(cmds, cmd);
  		}
--- 237,243 ----
  			/* Add a subcommand to make this one NOT NULL */
  			AlterTableCmd *cmd = makeNode(AlterTableCmd);
  
! 			cmd->subtype = AT_SetAttNotNull;
  			cmd->name = pstrdup(NameStr(attform->attname));
  			cmds = lappend(cmds, cmd);
  		}
*** a/src/backend/catalog/information_schema.sql
--- b/src/backend/catalog/information_schema.sql
***************
*** 427,450 **** CREATE VIEW check_constraints AS
             LEFT OUTER JOIN pg_class c ON (c.oid = con.conrelid)
             LEFT OUTER JOIN pg_type t ON (t.oid = con.contypid)
      WHERE pg_has_role(coalesce(c.relowner, t.typowner), 'USAGE')
!       AND con.contype = 'c'
! 
!     UNION
!     -- not-null constraints
! 
!     SELECT CAST(current_database() AS sql_identifier) AS constraint_catalog,
!            CAST(n.nspname AS sql_identifier) AS constraint_schema,
!            CAST(CAST(n.oid AS text) || '_' || CAST(r.oid AS text) || '_' || CAST(a.attnum AS text) || '_not_null' AS sql_identifier) AS constraint_name, -- XXX
!            CAST(a.attname || ' IS NOT NULL' AS character_data)
!              AS check_clause
!     FROM pg_namespace n, pg_class r, pg_attribute a
!     WHERE n.oid = r.relnamespace
!       AND r.oid = a.attrelid
!       AND a.attnum > 0
!       AND NOT a.attisdropped
!       AND a.attnotnull
!       AND r.relkind = 'r'
!       AND pg_has_role(r.relowner, 'USAGE');
  
  GRANT SELECT ON check_constraints TO PUBLIC;
  
--- 427,433 ----
             LEFT OUTER JOIN pg_class c ON (c.oid = con.conrelid)
             LEFT OUTER JOIN pg_type t ON (t.oid = con.contypid)
      WHERE pg_has_role(coalesce(c.relowner, t.typowner), 'USAGE')
!       AND con.contype = 'c';
  
  GRANT SELECT ON check_constraints TO PUBLIC;
  
***************
*** 1704,1710 **** CREATE VIEW table_constraints AS
               CASE c.contype WHEN 'c' THEN 'CHECK'
                              WHEN 'f' THEN 'FOREIGN KEY'
                              WHEN 'p' THEN 'PRIMARY KEY'
!                             WHEN 'u' THEN 'UNIQUE' END
               AS character_data) AS constraint_type,
             CAST(CASE WHEN c.condeferrable THEN 'YES' ELSE 'NO' END AS yes_or_no)
               AS is_deferrable,
--- 1687,1694 ----
               CASE c.contype WHEN 'c' THEN 'CHECK'
                              WHEN 'f' THEN 'FOREIGN KEY'
                              WHEN 'p' THEN 'PRIMARY KEY'
!                             WHEN 'u' THEN 'UNIQUE'
! 							WHEN 'n' THEN 'NOT NULL' END
               AS character_data) AS constraint_type,
             CAST(CASE WHEN c.condeferrable THEN 'YES' ELSE 'NO' END AS yes_or_no)
               AS is_deferrable,
***************
*** 1724,1760 **** CREATE VIEW table_constraints AS
            AND (pg_has_role(r.relowner, 'USAGE')
                 -- SELECT privilege omitted, per SQL standard
                 OR has_table_privilege(r.oid, 'INSERT, UPDATE, DELETE, TRUNCATE, REFERENCES, TRIGGER')
!                OR has_any_column_privilege(r.oid, 'INSERT, UPDATE, REFERENCES') )
! 
!     UNION ALL
! 
!     -- not-null constraints
! 
!     SELECT CAST(current_database() AS sql_identifier) AS constraint_catalog,
!            CAST(nr.nspname AS sql_identifier) AS constraint_schema,
!            CAST(CAST(nr.oid AS text) || '_' || CAST(r.oid AS text) || '_' || CAST(a.attnum AS text) || '_not_null' AS sql_identifier) AS constraint_name, -- XXX
!            CAST(current_database() AS sql_identifier) AS table_catalog,
!            CAST(nr.nspname AS sql_identifier) AS table_schema,
!            CAST(r.relname AS sql_identifier) AS table_name,
!            CAST('CHECK' AS character_data) AS constraint_type,
!            CAST('NO' AS yes_or_no) AS is_deferrable,
!            CAST('NO' AS yes_or_no) AS initially_deferred
! 
!     FROM pg_namespace nr,
!          pg_class r,
!          pg_attribute a
! 
!     WHERE nr.oid = r.relnamespace
!           AND r.oid = a.attrelid
!           AND a.attnotnull
!           AND a.attnum > 0
!           AND NOT a.attisdropped
!           AND r.relkind = 'r'
!           AND (NOT pg_is_other_temp_schema(nr.oid))
!           AND (pg_has_role(r.relowner, 'USAGE')
!                -- SELECT privilege omitted, per SQL standard
!                OR has_table_privilege(r.oid, 'INSERT, UPDATE, DELETE, TRUNCATE, REFERENCES, TRIGGER')
!                OR has_any_column_privilege(r.oid, 'INSERT, UPDATE, REFERENCES') );
  
  GRANT SELECT ON table_constraints TO PUBLIC;
  
--- 1708,1714 ----
            AND (pg_has_role(r.relowner, 'USAGE')
                 -- SELECT privilege omitted, per SQL standard
                 OR has_table_privilege(r.oid, 'INSERT, UPDATE, DELETE, TRUNCATE, REFERENCES, TRIGGER')
!                OR has_any_column_privilege(r.oid, 'INSERT, UPDATE, REFERENCES') ) ;
  
  GRANT SELECT ON table_constraints TO PUBLIC;
  
